#include <AFMotor.h>
#include <ServoTimer1.h>

//robot v.01 works with v13 of the Arduino IDE

int minsafedist = 12; // make sure you have the letter case the same when typing
AF_DCMotor motor(1, MOTOR12_64KHZ);
AF_DCMotor motor2(2, MOTOR12_64KHZ);
unsigned long echo = 0;
unsigned long pingvalue = 0;
int pingSignal = 19;
ServoTimer1 servo1;
int servocenter = 84; //this number is closer to center for my  servo fiddle with it
int servoleft = 160; //pick number you like to turn its head
int servoright = 20;

// pan ping dist var
int leftDist = 0;
int rightDist = 0;
int centerDist = 0;

//buffer 
int actionBuffer[10];
void initBuffer(){
  for(int i = 0; i < 10; i++){
    actionBuffer[i] = 0;
  }
}
void pushBuffer(int x){
  for(int i =0; i < 9; i++){
    actionBuffer[i+1] = actionBuffer[i];
  }
  actionBuffer[0] = x;
}
int oscillating(){
  int osc = 0;
  for(int i = 0; i < 5; i++){
    if ((actionBuffer[i] == 1)||(actionBuffer[i] == 2)){
      osc++;
    }
  }
  return osc;
}
void setup()
{
  motor.setSpeed(255);
  motor2.setSpeed(255);
  servo1.attach(10);
  servo1.write(84);
  initBuffer();

  Serial.begin(9600);
  Serial.println("starting");

}
unsigned long ping1(){
  pinMode(pingSignal, OUTPUT); // Switch signalpin to output
  digitalWrite(pingSignal, LOW); // Send low pulse
  delayMicroseconds(2); // Wait for 2 microseconds
  digitalWrite(pingSignal, HIGH); // Send high pulse
  delayMicroseconds(5); // Wait for 5 microseconds
  digitalWrite(pingSignal, LOW); // Holdoff
  pinMode(pingSignal, INPUT); // Switch signalpin to input
  digitalWrite(pingSignal, HIGH); // Turn on pullup resistor

  echo = pulseIn(pingSignal, HIGH); //Listen for echo
  pingvalue = (echo / 58.138) * .39; //convert to CM then to inches
  Serial.println(pingvalue);
  return pingvalue;
}

void stop(){
  motor.run(RELEASE);
  motor2.run(RELEASE);
  Serial.print("stop");
}

void Forward(){
  motor.run(FORWARD);
  motor2.run(FORWARD);
  Serial.print("forwards");
}

void SpinRight(){
  motor.run(BACKWARD);
  motor2.run(FORWARD);
  Serial.print("right");  
}

void SpinLeft(){
  motor.run(FORWARD);
  motor2.run(BACKWARD);
  Serial.print("left");
}

void LookAround(){
  servo1.write(servoleft); //left servo
  delay(500);                  // waits for a second
  leftDist = ping1();
  servo1.write(servocenter); //center our servo
  delay(500);                  // waits for a second
  centerDist = ping1();
  servo1.write(servoright); //right servo
  delay(500);                  // waits for a second
  rightDist = ping1();
  servo1.write(servocenter); //center our servo
  delay(500);                  // waits for a second
  Serial.println(leftDist);
  Serial.println(centerDist);
  Serial.println(rightDist);
}

void LookAhead(){
  //servo1.write(servocenter); //center our servo
  //delay(175);                  // waits for a second
  centerDist = ping1();
}

void loop()                     // run over and over again
{
  LookAhead();
  //LookAround();

  if(centerDist >= minsafedist){
    Forward();
    pushBuffer(0);
    delay(100);
  }
  else{
    //stop
    stop();
    delay(100); 

    //have a look around
    LookAround();
    if((oscillating() > 2)||(rightDist == leftDist)){
      //best to turn around
      SpinLeft();
      initBuffer();
      pushBuffer(3);
      delay(2000);
      //go in the direction that read farthest
    }
    else if(leftDist > rightDist){
      //best to turn left
      SpinLeft();
      pushBuffer(1);
      delay(500);
    }
    else if(rightDist >leftDist){
      //best to turn right
      SpinRight();
      pushBuffer(2);
      delay(500); 
    }
    else{
      //this should NEVER happen
      //best to turn around
      SpinLeft();
      initBuffer();
      pushBuffer(3);
      delay(2000);
    }
  }
  delay(100);  
}
